# azure.mgmt.devtestlabs.models module

class `azure.mgmt.devtestlabs.models.``ApplicableSchedule`(*, location: str = None, tags=None, lab_vms_shutdown=None, lab_vms_startup=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  Schedules applicable to a virtual machine. The schedules may have been defined on a VM or on lab level.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - lab_vms_shutdown (Schedule) – The auto-shutdown schedule, if one has been set at the lab or lab resource level.
  - lab_vms_startup (Schedule) – The auto-startup schedule, if one has been set at the lab or lab resource level.

class `azure.mgmt.devtestlabs.models.``ApplicableScheduleFragment`(*, tags=None, lab_vms_shutdown=None, lab_vms_startup=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  Schedules applicable to a virtual machine. The schedules may have been defined on a VM or on lab level.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - lab_vms_shutdown (ScheduleFragment) – The auto-shutdown schedule, if one has been set at the lab or lab resource level.
  - lab_vms_startup (ScheduleFragment) – The auto-startup schedule, if one has been set at the lab or lab resource level.

class `azure.mgmt.devtestlabs.models.``ApplyArtifactsRequest`(*, artifacts=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Request body for applying artifacts to a virtual machine.

  Parameters: | artifacts (list[ArtifactInstallProperties]) – The list of artifacts to apply.

class `azure.mgmt.devtestlabs.models.``ArmTemplate`(*, location: str = None, tags=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  An Azure Resource Manager template.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - display_name (str) – The display name of the ARM template.
  - description (str) – The description of the ARM template.
  - publisher (str) – The publisher of the ARM template.
  - icon (str) – The URI to the icon of the ARM template.
  - contents (object) – The contents of the ARM template.
  - created_date (datetime) – The creation date of the armTemplate.
  - parameters_value_files_info (list[ParametersValueFileInfo]) – File name and parameter values information from all azuredeploy.*.parameters.json for the ARM template.
  - enabled (bool) – Whether or not ARM template is enabled for use by lab user.

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``ArmTemplateInfo`(*, template=None, parameters=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about a generated ARM template.

  Parameters:

  - template (object) – The template’s contents.
  - parameters (object) – The parameters of the ARM template.

class `azure.mgmt.devtestlabs.models.``ArmTemplateParameterProperties`(*, name: str = None, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an Azure Resource Manager template parameter.

  Parameters:

  - name (str) – The name of the template parameter.
  - value (str) – The value of the template parameter.

class `azure.mgmt.devtestlabs.models.``ArmTemplateParameterPropertiesFragment`(*, name: str = None, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an Azure Resource Manager template parameter.

  Parameters:

  - name (str) – The name of the template parameter.
  - value (str) – The value of the template parameter.

class `azure.mgmt.devtestlabs.models.``Artifact`(*, location: str = None, tags=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  An artifact.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - title (str) – The artifact’s title.
  - description (str) – The artifact’s description.
  - publisher (str) – The artifact’s publisher.
  - file_path (str) – The file path to the artifact.
  - icon (str) – The URI to the artifact icon.
  - target_os_type (str) – The artifact’s target OS.
  - parameters (object) – The artifact’s parameters.
  - created_date (datetime) – The artifact’s creation date.

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``ArtifactDeploymentStatusProperties`(*, deployment_status: str = None, artifacts_applied: int = None, total_artifacts: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an artifact deployment.

  Parameters:

  - deployment_status (str) – The deployment status of the artifact.
  - artifacts_applied (int) – The total count of the artifacts that were successfully applied.
  - total_artifacts (int) – The total count of the artifacts that were tentatively applied.

class `azure.mgmt.devtestlabs.models.``ArtifactDeploymentStatusPropertiesFragment`(*, deployment_status: str = None, artifacts_applied: int = None, total_artifacts: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an artifact deployment.

  Parameters:

  - deployment_status (str) – The deployment status of the artifact.
  - artifacts_applied (int) – The total count of the artifacts that were successfully applied.
  - total_artifacts (int) – The total count of the artifacts that were tentatively applied.

class `azure.mgmt.devtestlabs.models.``ArtifactInstallProperties`(*, artifact_id: str = None, artifact_title: str = None, parameters=None, status: str = None, deployment_status_message: str = None, vm_extension_status_message: str = None, install_time=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an artifact.

  Parameters:

  - artifact_id (str) – The artifact’s identifier.
  - artifact_title (str) – The artifact’s title.
  - parameters (list[ArtifactParameterProperties]) – The parameters of the artifact.
  - status (str) – The status of the artifact.
  - deployment_status_message (str) – The status message from the deployment.
  - vm_extension_status_message (str) – The status message from the virtual machine extension.
  - install_time (datetime) – The time that the artifact starts to install on the virtual machine.

class `azure.mgmt.devtestlabs.models.``ArtifactInstallPropertiesFragment`(*, artifact_id: str = None, artifact_title: str = None, parameters=None, status: str = None, deployment_status_message: str = None, vm_extension_status_message: str = None, install_time=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an artifact.

  Parameters:

  - artifact_id (str) – The artifact’s identifier.
  - artifact_title (str) – The artifact’s title.
  - parameters (list[ArtifactParameterPropertiesFragment]) – The parameters of the artifact.
  - status (str) – The status of the artifact.
  - deployment_status_message (str) – The status message from the deployment.
  - vm_extension_status_message (str) – The status message from the virtual machine extension.
  - install_time (datetime) – The time that the artifact starts to install on the virtual machine.

class `azure.mgmt.devtestlabs.models.``ArtifactParameterProperties`(*, name: str = None, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an artifact parameter.

  Parameters:

  - name (str) – The name of the artifact parameter.
  - value (str) – The value of the artifact parameter.

class `azure.mgmt.devtestlabs.models.``ArtifactParameterPropertiesFragment`(*, name: str = None, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an artifact parameter.

  Parameters:

  - name (str) – The name of the artifact parameter.
  - value (str) – The value of the artifact parameter.

class `azure.mgmt.devtestlabs.models.``ArtifactSource`(*, location: str = None, tags=None, display_name: str = None, uri: str = None, source_type=None, folder_path: str = None, arm_template_folder_path: str = None, branch_ref: str = None, security_token: str = None, status=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  Properties of an artifact source.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - created_date (datetime) – The artifact source’s creation date.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - display_name (str) – The artifact source’s display name.
  - uri (str) – The artifact source’s URI.
  - source_type (str or SourceControlType) – The artifact source’s type. Possible values include: ‘VsoGit’, ‘GitHub’
  - folder_path (str) – The folder containing artifacts.
  - arm_template_folder_path (str) – The folder containing Azure Resource Manager templates.
  - branch_ref (str) – The artifact source’s branch reference.
  - security_token (str) – The security token to authenticate to the artifact source.
  - status (str or EnableStatus) – Indicates if the artifact source is enabled (values: Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’

class `azure.mgmt.devtestlabs.models.``ArtifactSourceFragment`(*, tags=None, display_name: str = None, uri: str = None, source_type=None, folder_path: str = None, arm_template_folder_path: str = None, branch_ref: str = None, security_token: str = None, status=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  Properties of an artifact source.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - display_name (str) – The artifact source’s display name.
  - uri (str) – The artifact source’s URI.
  - source_type (str or SourceControlType) – The artifact source’s type. Possible values include: ‘VsoGit’, ‘GitHub’
  - folder_path (str) – The folder containing artifacts.
  - arm_template_folder_path (str) – The folder containing Azure Resource Manager templates.
  - branch_ref (str) – The artifact source’s branch reference.
  - security_token (str) – The security token to authenticate to the artifact source.
  - status (str or EnableStatus) – Indicates if the artifact source is enabled (values: Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’

class `azure.mgmt.devtestlabs.models.``AttachDiskProperties`(*, leased_by_lab_vm_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of the disk to attach.

  Parameters: | leased_by_lab_vm_id (str) – The resource ID of the Lab virtual machine to which the disk is attached.

class `azure.mgmt.devtestlabs.models.``AttachNewDataDiskOptions`(*, disk_size_gi_b: int = None, disk_name: str = None, disk_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties to attach new disk to the Virtual Machine.

  Parameters:

  - disk_size_gi_b (int) – Size of the disk to be attached in GibiBytes.
  - disk_name (str) – The name of the disk to be attached.
  - disk_type (str or StorageType) – The storage type for the disk (i.e. Standard, Premium). Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’

class `azure.mgmt.devtestlabs.models.``AttachNewDataDiskOptionsFragment`(*, disk_size_gi_b: int = None, disk_name: str = None, disk_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties to attach new disk to the Virtual Machine.

  Parameters:

  - disk_size_gi_b (int) – Size of the disk to be attached in GibiBytes.
  - disk_name (str) – The name of the disk to be attached.
  - disk_type (str or StorageType) – The storage type for the disk (i.e. Standard, Premium). Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’

class `azure.mgmt.devtestlabs.models.``BulkCreationParameters`(*, instance_count: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters for creating multiple virtual machines as a single action.

  Parameters: | instance_count (int) – The number of virtual machine instances to create.

class `azure.mgmt.devtestlabs.models.``BulkCreationParametersFragment`(*, instance_count: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters for creating multiple virtual machines as a single action.

  Parameters: | instance_count (int) – The number of virtual machine instances to create.

class `azure.mgmt.devtestlabs.models.``ComputeDataDisk`(*, name: str = None, disk_uri: str = None, managed_disk_id: str = None, disk_size_gi_b: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  A data disks attached to a virtual machine.

  Parameters:

  - name (str) – Gets data disk name.
  - disk_uri (str) – When backed by a blob, the URI of underlying blob.
  - managed_disk_id (str) – When backed by managed disk, this is the ID of the compute disk resource.
  - disk_size_gi_b (int) – Gets data disk size in GiB.

class `azure.mgmt.devtestlabs.models.``ComputeDataDiskFragment`(*, name: str = None, disk_uri: str = None, managed_disk_id: str = None, disk_size_gi_b: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  A data disks attached to a virtual machine.

  Parameters:

  - name (str) – Gets data disk name.
  - disk_uri (str) – When backed by a blob, the URI of underlying blob.
  - managed_disk_id (str) – When backed by managed disk, this is the ID of the compute disk resource.
  - disk_size_gi_b (int) – Gets data disk size in GiB.

class `azure.mgmt.devtestlabs.models.``ComputeVmInstanceViewStatus`(*, code: str = None, display_status: str = None, message: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Status information about a virtual machine.

  Parameters:

  - code (str) – Gets the status Code.
  - display_status (str) – Gets the short localizable label for the status.
  - message (str) – Gets the message associated with the status.

class `azure.mgmt.devtestlabs.models.``ComputeVmInstanceViewStatusFragment`(*, code: str = None, display_status: str = None, message: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Status information about a virtual machine.

  Parameters:

  - code (str) – Gets the status Code.
  - display_status (str) – Gets the short localizable label for the status.
  - message (str) – Gets the message associated with the status.

class `azure.mgmt.devtestlabs.models.``ComputeVmProperties`(*, statuses=None, os_type: str = None, vm_size: str = None, network_interface_id: str = None, os_disk_id: str = None, data_disk_ids=None, data_disks=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a virtual machine returned by the Microsoft.Compute API.

  Parameters:

  - statuses (list[ComputeVmInstanceViewStatus]) – Gets the statuses of the virtual machine.
  - os_type (str) – Gets the OS type of the virtual machine.
  - vm_size (str) – Gets the size of the virtual machine.
  - network_interface_id (str) – Gets the network interface ID of the virtual machine.
  - os_disk_id (str) – Gets OS disk blob uri for the virtual machine.
  - data_disk_ids (list[str]) – Gets data disks blob uri for the virtual machine.
  - data_disks (list[ComputeDataDisk]) – Gets all data disks attached to the virtual machine.

class `azure.mgmt.devtestlabs.models.``ComputeVmPropertiesFragment`(*, statuses=None, os_type: str = None, vm_size: str = None, network_interface_id: str = None, os_disk_id: str = None, data_disk_ids=None, data_disks=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a virtual machine returned by the Microsoft.Compute API.

  Parameters:

  - statuses (list[ComputeVmInstanceViewStatusFragment]) – Gets the statuses of the virtual machine.
  - os_type (str) – Gets the OS type of the virtual machine.
  - vm_size (str) – Gets the size of the virtual machine.
  - network_interface_id (str) – Gets the network interface ID of the virtual machine.
  - os_disk_id (str) – Gets OS disk blob uri for the virtual machine.
  - data_disk_ids (list[str]) – Gets data disks blob uri for the virtual machine.
  - data_disks (list[ComputeDataDiskFragment]) – Gets all data disks attached to the virtual machine.

class `azure.mgmt.devtestlabs.models.``CostThresholdProperties`(*, threshold_id: str = None, percentage_threshold=None, display_on_chart=None, send_notification_when_exceeded=None, notification_sent: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a cost threshold item.

  Parameters:

  - threshold_id (str) – The ID of the cost threshold item.
  - percentage_threshold (PercentageCostThresholdProperties) – The value of the percentage cost threshold.
  - display_on_chart (str or CostThresholdStatus) – Indicates whether this threshold will be displayed on cost charts. Possible values include: ‘Enabled’, ‘Disabled’
  - send_notification_when_exceeded (str or CostThresholdStatus) – Indicates whether notifications will be sent when this threshold is exceeded. Possible values include: ‘Enabled’, ‘Disabled’
  - notification_sent (str) – Indicates the datetime when notifications were last sent for this threshold.

class `azure.mgmt.devtestlabs.models.``CustomImage`(*, location: str = None, tags=None, vm=None, vhd=None, description: str = None, author: str = None, managed_image_id: str = None, managed_snapshot_id: str = None, data_disk_storage_info=None, custom_image_plan=None, is_plan_authorized: bool = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A custom image.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - creation_date (datetime) – The creation date of the custom image.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - vm (CustomImagePropertiesFromVm) – The virtual machine from which the image is to be created.
  - vhd (CustomImagePropertiesCustom) – The VHD from which the image is to be created.
  - description (str) – The description of the custom image.
  - author (str) – The author of the custom image.
  - managed_image_id (str) – The Managed Image Id backing the custom image.
  - managed_snapshot_id (str) – The Managed Snapshot Id backing the custom image.
  - data_disk_storage_info (list[DataDiskStorageTypeInfo]) – Storage information about the data disks present in the custom image
  - custom_image_plan (CustomImagePropertiesFromPlan) – Storage information about the plan related to this custom image
  - is_plan_authorized (bool) – Whether or not the custom images underlying offer/plan has been enabled for programmatic deployment

class `azure.mgmt.devtestlabs.models.``CustomImageFragment`(*, tags=None, vm=None, vhd=None, description: str = None, author: str = None, managed_image_id: str = None, managed_snapshot_id: str = None, data_disk_storage_info=None, custom_image_plan=None, is_plan_authorized: bool = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A custom image.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - vm (CustomImagePropertiesFromVmFragment) – The virtual machine from which the image is to be created.
  - vhd (CustomImagePropertiesCustomFragment) – The VHD from which the image is to be created.
  - description (str) – The description of the custom image.
  - author (str) – The author of the custom image.
  - managed_image_id (str) – The Managed Image Id backing the custom image.
  - managed_snapshot_id (str) – The Managed Snapshot Id backing the custom image.
  - data_disk_storage_info (list[DataDiskStorageTypeInfoFragment]) – Storage information about the data disks present in the custom image
  - custom_image_plan (CustomImagePropertiesFromPlanFragment) – Storage information about the plan related to this custom image
  - is_plan_authorized (bool) – Whether or not the custom images underlying offer/plan has been enabled for programmatic deployment

class `azure.mgmt.devtestlabs.models.``CustomImagePropertiesCustom`(*, os_type, image_name: str = None, sys_prep: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a custom image from a VHD.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - image_name (str) – The image name.
  - sys_prep (bool) – Indicates whether sysprep has been run on the VHD.
  - os_type (str or CustomImageOsType) – Required. The OS type of the custom image (i.e. Windows, Linux). Possible values include: ‘Windows’, ‘Linux’, ‘None’

class `azure.mgmt.devtestlabs.models.``CustomImagePropertiesCustomFragment`(*, image_name: str = None, sys_prep: bool = None, os_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a custom image from a VHD.

  Parameters:

  - image_name (str) – The image name.
  - sys_prep (bool) – Indicates whether sysprep has been run on the VHD.
  - os_type (str or CustomImageOsType) – The OS type of the custom image (i.e. Windows, Linux). Possible values include: ‘Windows’, ‘Linux’, ‘None’

class `azure.mgmt.devtestlabs.models.``CustomImagePropertiesFromPlan`(*, id: str = None, publisher: str = None, offer: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for plan on a custom image.

  Parameters:

  - id (str) – The id of the plan, equivalent to name of the plan
  - publisher (str) – The publisher for the plan from the marketplace image the custom image is derived from
  - offer (str) – The offer for the plan from the marketplace image the custom image is derived from

class `azure.mgmt.devtestlabs.models.``CustomImagePropertiesFromPlanFragment`(*, id: str = None, publisher: str = None, offer: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for plan on a custom image.

  Parameters:

  - id (str) – The id of the plan, equivalent to name of the plan
  - publisher (str) – The publisher for the plan from the marketplace image the custom image is derived from
  - offer (str) – The offer for the plan from the marketplace image the custom image is derived from

class `azure.mgmt.devtestlabs.models.``CustomImagePropertiesFromVm`(*, source_vm_id: str = None, windows_os_info=None, linux_os_info=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a custom image from a virtual machine.

  Parameters:

  - source_vm_id (str) – The source vm identifier.
  - windows_os_info (WindowsOsInfo) – The Windows OS information of the VM.
  - linux_os_info (LinuxOsInfo) – The Linux OS information of the VM.

class `azure.mgmt.devtestlabs.models.``CustomImagePropertiesFromVmFragment`(*, source_vm_id: str = None, windows_os_info=None, linux_os_info=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a custom image from a virtual machine.

  Parameters:

  - source_vm_id (str) – The source vm identifier.
  - windows_os_info (WindowsOsInfoFragment) – The Windows OS information of the VM.
  - linux_os_info (LinuxOsInfoFragment) – The Linux OS information of the VM.

class `azure.mgmt.devtestlabs.models.``DataDiskProperties`(*, attach_new_data_disk_options=None, existing_lab_disk_id: str = None, host_caching=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Request body for adding a new or existing data disk to a virtual machine.

  Parameters:

  - attach_new_data_disk_options (AttachNewDataDiskOptions) – Specifies options to attach a new disk to the virtual machine.
  - existing_lab_disk_id (str) – Specifies the existing lab disk id to attach to virtual machine.
  - host_caching (str or HostCachingOptions) – Caching option for a data disk (i.e. None, ReadOnly, ReadWrite). Possible values include: ‘None’, ‘ReadOnly’, ‘ReadWrite’

class `azure.mgmt.devtestlabs.models.``DataDiskPropertiesFragment`(*, attach_new_data_disk_options=None, existing_lab_disk_id: str = None, host_caching=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Request body for adding a new or existing data disk to a virtual machine.

  Parameters:

  - attach_new_data_disk_options (AttachNewDataDiskOptionsFragment) – Specifies options to attach a new disk to the virtual machine.
  - existing_lab_disk_id (str) – Specifies the existing lab disk id to attach to virtual machine.
  - host_caching (str or HostCachingOptions) – Caching option for a data disk (i.e. None, ReadOnly, ReadWrite). Possible values include: ‘None’, ‘ReadOnly’, ‘ReadWrite’

class `azure.mgmt.devtestlabs.models.``DataDiskStorageTypeInfo`(*, lun: str = None, storage_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Storage information about the data disks present in the custom image.

  Parameters:

  - lun (str) – Disk Lun
  - storage_type (str or StorageType) – Disk Storage Type. Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’

class `azure.mgmt.devtestlabs.models.``DataDiskStorageTypeInfoFragment`(*, lun: str = None, storage_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Storage information about the data disks present in the custom image.

  Parameters:

  - lun (str) – Disk Lun
  - storage_type (str or StorageType) – Disk Storage Type. Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’

class `azure.mgmt.devtestlabs.models.``DayDetails`(*, time: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a daily schedule.

  Parameters: | time (str) – The time of day the schedule will occur.

class `azure.mgmt.devtestlabs.models.``DayDetailsFragment`(*, time: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a daily schedule.

  Parameters: | time (str) – The time of day the schedule will occur.

class `azure.mgmt.devtestlabs.models.``DetachDataDiskProperties`(*, existing_lab_disk_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Request body for detaching data disk from a virtual machine.

  Parameters: | existing_lab_disk_id (str) – Specifies the disk resource ID to detach from virtual machine.

class `azure.mgmt.devtestlabs.models.``DetachDiskProperties`(*, leased_by_lab_vm_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of the disk to detach.

  Parameters: | leased_by_lab_vm_id (str) – The resource ID of the Lab VM to which the disk is attached.

class `azure.mgmt.devtestlabs.models.``Disk`(*, location: str = None, tags=None, disk_type=None, disk_size_gi_b: int = None, leased_by_lab_vm_id: str = None, disk_blob_name: str = None, disk_uri: str = None, host_caching: str = None, managed_disk_id: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A Disk.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - created_date (datetime) – The creation date of the disk.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - disk_type (str or StorageType) – The storage type for the disk (i.e. Standard, Premium). Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’
  - disk_size_gi_b (int) – The size of the disk in GibiBytes.
  - leased_by_lab_vm_id (str) – The resource ID of the VM to which this disk is leased.
  - disk_blob_name (str) – When backed by a blob, the name of the VHD blob without extension.
  - disk_uri (str) – When backed by a blob, the URI of underlying blob.
  - host_caching (str) – The host caching policy of the disk (i.e. None, ReadOnly, ReadWrite).
  - managed_disk_id (str) – When backed by managed disk, this is the ID of the compute disk resource.

class `azure.mgmt.devtestlabs.models.``DiskFragment`(*, tags=None, disk_type=None, disk_size_gi_b: int = None, leased_by_lab_vm_id: str = None, disk_blob_name: str = None, disk_uri: str = None, host_caching: str = None, managed_disk_id: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A Disk.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - disk_type (str or StorageType) – The storage type for the disk (i.e. Standard, Premium). Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’
  - disk_size_gi_b (int) – The size of the disk in GibiBytes.
  - leased_by_lab_vm_id (str) – The resource ID of the VM to which this disk is leased.
  - disk_blob_name (str) – When backed by a blob, the name of the VHD blob without extension.
  - disk_uri (str) – When backed by a blob, the URI of underlying blob.
  - host_caching (str) – The host caching policy of the disk (i.e. None, ReadOnly, ReadWrite).
  - managed_disk_id (str) – When backed by managed disk, this is the ID of the compute disk resource.

class `azure.mgmt.devtestlabs.models.``DtlEnvironment`(*, location: str = None, tags=None, deployment_properties=None, arm_template_display_name: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  An environment, which is essentially an ARM template deployment.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - resource_group_id (str) – The identifier of the resource group containing the environment’s resources.
  - created_by_user (str) – The creator of the environment.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - deployment_properties (EnvironmentDeploymentProperties) – The deployment properties of the environment.
  - arm_template_display_name (str) – The display name of the Azure Resource Manager template that produced the environment.

class `azure.mgmt.devtestlabs.models.``DtlEnvironmentFragment`(*, tags=None, deployment_properties=None, arm_template_display_name: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  An environment, which is essentially an ARM template deployment.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - deployment_properties (EnvironmentDeploymentPropertiesFragment) – The deployment properties of the environment.
  - arm_template_display_name (str) – The display name of the Azure Resource Manager template that produced the environment.

class `azure.mgmt.devtestlabs.models.``EnvironmentDeploymentProperties`(*, arm_template_id: str = None, parameters=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an environment deployment.

  Parameters:

  - arm_template_id (str) – The Azure Resource Manager template’s identifier.
  - parameters (list[ArmTemplateParameterProperties]) – The parameters of the Azure Resource Manager template.

class `azure.mgmt.devtestlabs.models.``EnvironmentDeploymentPropertiesFragment`(*, arm_template_id: str = None, parameters=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an environment deployment.

  Parameters:

  - arm_template_id (str) – The Azure Resource Manager template’s identifier.
  - parameters (list[ArmTemplateParameterPropertiesFragment]) – The parameters of the Azure Resource Manager template.

class `azure.mgmt.devtestlabs.models.``EvaluatePoliciesProperties`(*, fact_name: str = None, fact_data: str = None, value_offset: str = None, user_object_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for evaluating a policy set.

  Parameters:

  - fact_name (str) – The fact name.
  - fact_data (str) – The fact data.
  - value_offset (str) – The value offset.
  - user_object_id (str) – The user for which policies will be evaluated

class `azure.mgmt.devtestlabs.models.``EvaluatePoliciesRequest`(*, policies=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Request body for evaluating a policy set.

  Parameters: | policies (list[EvaluatePoliciesProperties]) – Policies to evaluate.

class `azure.mgmt.devtestlabs.models.``EvaluatePoliciesResponse`(*, results=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Response body for evaluating a policy set.

  Parameters: | results (list[PolicySetResult]) – Results of evaluating a policy set.

class `azure.mgmt.devtestlabs.models.``Event`(*, event_name=None, **kwargs)

  Bases: `msrest.serialization.Model`

  An event to be notified for.

  Parameters: | event_name (str or NotificationChannelEventType) – The event type for which this notification is enabled (i.e. AutoShutdown, Cost). Possible values include: ‘AutoShutdown’, ‘Cost’

class `azure.mgmt.devtestlabs.models.``EventFragment`(*, event_name=None, **kwargs)

  Bases: `msrest.serialization.Model`

  An event to be notified for.

  Parameters: | event_name (str or NotificationChannelEventType) – The event type for which this notification is enabled (i.e. AutoShutdown, Cost). Possible values include: ‘AutoShutdown’, ‘Cost’

class `azure.mgmt.devtestlabs.models.``ExportResourceUsageParameters`(*, blob_storage_absolute_sas_uri: str = None, usage_start_date=None, **kwargs)

  Bases: `msrest.serialization.Model`

  The parameters of the export operation.

  Parameters:

  - blob_storage_absolute_sas_uri (str) – The blob storage absolute sas uri with write permission to the container which the usage data needs to be uploaded to.
  - usage_start_date (datetime) – The start time of the usage. If not provided, usage will be reported since the beginning of data collection.

class `azure.mgmt.devtestlabs.models.``ExternalSubnet`(*, id: str = None, name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subnet information as returned by the Microsoft.Network API.

  Parameters:

  - id (str) – Gets or sets the identifier.
  - name (str) – Gets or sets the name.

class `azure.mgmt.devtestlabs.models.``ExternalSubnetFragment`(*, id: str = None, name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subnet information as returned by the Microsoft.Network API.

  Parameters:

  - id (str) – Gets or sets the identifier.
  - name (str) – Gets or sets the name.

class `azure.mgmt.devtestlabs.models.``Formula`(*, location: str = None, tags=None, description: str = None, author: str = None, os_type: str = None, formula_content=None, vm=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A formula for creating a VM, specifying an image base and other parameters.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - creation_date (datetime) – The creation date of the formula.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - description (str) – The description of the formula.
  - author (str) – The author of the formula.
  - os_type (str) – The OS type of the formula.
  - formula_content (LabVirtualMachineCreationParameter) – The content of the formula.
  - vm (FormulaPropertiesFromVm) – Information about a VM from which a formula is to be created.

class `azure.mgmt.devtestlabs.models.``FormulaFragment`(*, tags=None, description: str = None, author: str = None, os_type: str = None, formula_content=None, vm=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A formula for creating a VM, specifying an image base and other parameters.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - description (str) – The description of the formula.
  - author (str) – The author of the formula.
  - os_type (str) – The OS type of the formula.
  - formula_content (LabVirtualMachineCreationParameterFragment) – The content of the formula.
  - vm (FormulaPropertiesFromVmFragment) – Information about a VM from which a formula is to be created.

class `azure.mgmt.devtestlabs.models.``FormulaPropertiesFromVm`(*, lab_vm_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about a VM from which a formula is to be created.

  Parameters: | lab_vm_id (str) – The identifier of the VM from which a formula is to be created.

class `azure.mgmt.devtestlabs.models.``FormulaPropertiesFromVmFragment`(*, lab_vm_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about a VM from which a formula is to be created.

  Parameters: | lab_vm_id (str) – The identifier of the VM from which a formula is to be created.

class `azure.mgmt.devtestlabs.models.``GalleryImage`(*, location: str = None, tags=None, author: str = None, description: str = None, image_reference=None, icon: str = None, enabled: bool = None, plan_id: str = None, is_plan_authorized: bool = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A gallery image.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - created_date (datetime) – The creation date of the gallery image.

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - author (str) – The author of the gallery image.
  - description (str) – The description of the gallery image.
  - image_reference (GalleryImageReference) – The image reference of the gallery image.
  - icon (str) – The icon of the gallery image.
  - enabled (bool) – Indicates whether this gallery image is enabled.
  - plan_id (str) – The third party plan that applies to this image
  - is_plan_authorized (bool) – Indicates if the plan has been authorized for programmatic deployment.

class `azure.mgmt.devtestlabs.models.``GalleryImageReference`(*, offer: str = None, publisher: str = None, sku: str = None, os_type: str = None, version: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The reference information for an Azure Marketplace image.

  Parameters:

  - offer (str) – The offer of the gallery image.
  - publisher (str) – The publisher of the gallery image.
  - sku (str) – The SKU of the gallery image.
  - os_type (str) – The OS type of the gallery image.
  - version (str) – The version of the gallery image.

class `azure.mgmt.devtestlabs.models.``GalleryImageReferenceFragment`(*, offer: str = None, publisher: str = None, sku: str = None, os_type: str = None, version: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The reference information for an Azure Marketplace image.

  Parameters:

  - offer (str) – The offer of the gallery image.
  - publisher (str) – The publisher of the gallery image.
  - sku (str) – The SKU of the gallery image.
  - os_type (str) – The OS type of the gallery image.
  - version (str) – The version of the gallery image.

class `azure.mgmt.devtestlabs.models.``GenerateArmTemplateRequest`(*, virtual_machine_name: str = None, parameters=None, location: str = None, file_upload_options=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters for generating an ARM template for deploying artifacts.

  Parameters:

  - virtual_machine_name (str) – The resource name of the virtual machine.
  - parameters (list[ParameterInfo]) – The parameters of the ARM template.
  - location (str) – The location of the virtual machine.
  - file_upload_options (str or FileUploadOptions) – Options for uploading the files for the artifact. UploadFilesAndGenerateSasTokens is the default value. Possible values include: ‘UploadFilesAndGenerateSasTokens’, ‘None’

class `azure.mgmt.devtestlabs.models.``GenerateUploadUriParameter`(*, blob_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for generating an upload URI.

  Parameters: | blob_name (str) – The blob name of the upload URI.

class `azure.mgmt.devtestlabs.models.``GenerateUploadUriResponse`(*, upload_uri: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Response body for generating an upload URI.

  Parameters: | upload_uri (str) – The upload URI for the VHD.

class `azure.mgmt.devtestlabs.models.``HourDetails`(*, minute: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an hourly schedule.

  Parameters: | minute (int) – Minutes of the hour the schedule will run.

class `azure.mgmt.devtestlabs.models.``HourDetailsFragment`(*, minute: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of an hourly schedule.

  Parameters: | minute (int) – Minutes of the hour the schedule will run.

class `azure.mgmt.devtestlabs.models.``IdentityProperties`(*, type: str = None, principal_id: str = None, tenant_id: str = None, client_secret_url: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a managed identity.

  Parameters:

  - type (str) – Managed identity.
  - principal_id (str) – The principal id of resource identity.
  - tenant_id (str) – The tenant identifier of resource.
  - client_secret_url (str) – The client secret URL of the identity.

class `azure.mgmt.devtestlabs.models.``ImportLabVirtualMachineRequest`(*, source_virtual_machine_resource_id: str = None, destination_virtual_machine_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  This represents the payload required to import a virtual machine from a different lab into the current one.

  Parameters:

  - source_virtual_machine_resource_id (str) – The full resource ID of the virtual machine to be imported.
  - destination_virtual_machine_name (str) – The name of the virtual machine in the destination lab

class `azure.mgmt.devtestlabs.models.``InboundNatRule`(*, transport_protocol=None, frontend_port: int = None, backend_port: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  A rule for NAT - exposing a VM’s port (backendPort) on the public IP address using a load balancer.

  Parameters:

  - transport_protocol (str or TransportProtocol) – The transport protocol for the endpoint. Possible values include: ‘Tcp’, ‘Udp’
  - frontend_port (int) – The external endpoint port of the inbound connection. Possible values range between 1 and 65535, inclusive. If unspecified, a value will be allocated automatically.
  - backend_port (int) – The port to which the external traffic will be redirected.

class `azure.mgmt.devtestlabs.models.``InboundNatRuleFragment`(*, transport_protocol=None, frontend_port: int = None, backend_port: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  A rule for NAT - exposing a VM’s port (backendPort) on the public IP address using a load balancer.

  Parameters:

  - transport_protocol (str or TransportProtocol) – The transport protocol for the endpoint. Possible values include: ‘Tcp’, ‘Udp’
  - frontend_port (int) – The external endpoint port of the inbound connection. Possible values range between 1 and 65535, inclusive. If unspecified, a value will be allocated automatically.
  - backend_port (int) – The port to which the external traffic will be redirected.

class `azure.mgmt.devtestlabs.models.``Lab`(*, location: str = None, tags=None, lab_storage_type=None, mandatory_artifacts_resource_ids_linux=None, mandatory_artifacts_resource_ids_windows=None, premium_data_disks=None, environment_permission=None, announcement=None, support=None, extended_properties=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A lab.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - default_storage_account (str) – The lab’s default storage account.
  - default_premium_storage_account (str) – The lab’s default premium storage account.
  - artifacts_storage_account (str) – The lab’s artifact storage account.
  - premium_data_disk_storage_account (str) – The lab’s premium data disk storage account.
  - vault_name (str) – The lab’s Key vault.
  - created_date (datetime) – The creation date of the lab.
  - vm_creation_resource_group (str) – The resource group in which all new lab virtual machines will be created. To let DevTest Labs manage resource group creation, set this value to null.
  - public_ip_id (str) – The public IP address for the lab’s load balancer.
  - load_balancer_id (str) – The load balancer used to for lab VMs that use shared IP address.
  - network_security_group_id (str) – The Network Security Group attached to the lab VMs Network interfaces to restrict open ports.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - lab_storage_type (str or StorageType) – Type of storage used by the lab. It can be either Premium or Standard. Default is Premium. Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’
  - mandatory_artifacts_resource_ids_linux (list[str]) – The ordered list of artifact resource IDs that should be applied on all Linux VM creations by default, prior to the artifacts specified by the user.
  - mandatory_artifacts_resource_ids_windows (list[str]) – The ordered list of artifact resource IDs that should be applied on all Windows VM creations by default, prior to the artifacts specified by the user.
  - premium_data_disks (str or PremiumDataDisk) – The setting to enable usage of premium data disks. When its value is ‘Enabled’, creation of standard or premium data disks is allowed. When its value is ‘Disabled’, only creation of standard data disks is allowed. Possible values include: ‘Disabled’, ‘Enabled’
  - environment_permission (str or EnvironmentPermission) – The access rights to be granted to the user when provisioning an environment. Possible values include: ‘Reader’, ‘Contributor’
  - announcement (LabAnnouncementProperties) – The properties of any lab announcement associated with this lab
  - support (LabSupportProperties) – The properties of any lab support message associated with this lab
  - extended_properties (dict[str, str]) – Extended properties of the lab used for experimental features

class `azure.mgmt.devtestlabs.models.``LabAnnouncementProperties`(*, title: str = None, markdown: str = None, enabled=None, expiration_date=None, expired: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a lab’s announcement banner.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - title (str) – The plain text title for the lab announcement
  - markdown (str) – The markdown text (if any) that this lab displays in the UI. If left empty/null, nothing will be shown.
  - enabled (str or EnableStatus) – Is the lab announcement active/enabled at this time?. Possible values include: ‘Enabled’, ‘Disabled’
  - expiration_date (datetime) – The time at which the announcement expires (null for never)
  - expired (bool) – Has this announcement expired?

  Variables:

  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

class `azure.mgmt.devtestlabs.models.``LabAnnouncementPropertiesFragment`(*, title: str = None, markdown: str = None, enabled=None, expiration_date=None, expired: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a lab’s announcement banner.

  Parameters:

  - title (str) – The plain text title for the lab announcement
  - markdown (str) – The markdown text (if any) that this lab displays in the UI. If left empty/null, nothing will be shown.
  - enabled (str or EnableStatus) – Is the lab announcement active/enabled at this time?. Possible values include: ‘Enabled’, ‘Disabled’
  - expiration_date (datetime) – The time at which the announcement expires (null for never)
  - expired (bool) – Has this announcement expired?

class `azure.mgmt.devtestlabs.models.``LabCost`(*, location: str = None, tags=None, target_cost=None, currency_code: str = None, start_date_time=None, end_date_time=None, created_date=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A cost item.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - lab_cost_summary (LabCostSummaryProperties) – The lab cost summary component of the cost data.
  - lab_cost_details (list[LabCostDetailsProperties]) – The lab cost details component of the cost data.
  - resource_costs (list[LabResourceCostProperties]) – The resource cost component of the cost data.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - target_cost (TargetCostProperties) – The target cost properties
  - currency_code (str) – The currency code of the cost.
  - start_date_time (datetime) – The start time of the cost data.
  - end_date_time (datetime) – The end time of the cost data.
  - created_date (datetime) – The creation date of the cost.

class `azure.mgmt.devtestlabs.models.``LabCostDetailsProperties`(*, date_property=None, cost: float = None, cost_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  The properties of a lab cost item.

  Parameters:

  - date_property (datetime) – The date of the cost item.
  - cost (float) – The cost component of the cost item.
  - cost_type (str or CostType) – The type of the cost. Possible values include: ‘Unavailable’, ‘Reported’, ‘Projected’

class `azure.mgmt.devtestlabs.models.``LabCostSummaryProperties`(*, estimated_lab_cost: float = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The properties of the cost summary.

  Parameters: | estimated_lab_cost (float) – The cost component of the cost item.

class `azure.mgmt.devtestlabs.models.``LabFragment`(*, tags=None, lab_storage_type=None, mandatory_artifacts_resource_ids_linux=None, mandatory_artifacts_resource_ids_windows=None, premium_data_disks=None, environment_permission=None, announcement=None, support=None, extended_properties=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A lab.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - lab_storage_type (str or StorageType) – Type of storage used by the lab. It can be either Premium or Standard. Default is Premium. Possible values include: ‘Standard’, ‘Premium’, ‘StandardSSD’
  - mandatory_artifacts_resource_ids_linux (list[str]) – The ordered list of artifact resource IDs that should be applied on all Linux VM creations by default, prior to the artifacts specified by the user.
  - mandatory_artifacts_resource_ids_windows (list[str]) – The ordered list of artifact resource IDs that should be applied on all Windows VM creations by default, prior to the artifacts specified by the user.
  - premium_data_disks (str or PremiumDataDisk) – The setting to enable usage of premium data disks. When its value is ‘Enabled’, creation of standard or premium data disks is allowed. When its value is ‘Disabled’, only creation of standard data disks is allowed. Possible values include: ‘Disabled’, ‘Enabled’
  - environment_permission (str or EnvironmentPermission) – The access rights to be granted to the user when provisioning an environment. Possible values include: ‘Reader’, ‘Contributor’
  - announcement (LabAnnouncementPropertiesFragment) – The properties of any lab announcement associated with this lab
  - support (LabSupportPropertiesFragment) – The properties of any lab support message associated with this lab
  - extended_properties (dict[str, str]) – Extended properties of the lab used for experimental features

class `azure.mgmt.devtestlabs.models.``LabResourceCostProperties`(*, resourcename: str = None, resource_uid: str = None, resource_cost: float = None, resource_type: str = None, resource_owner: str = None, resource_pricing_tier: str = None, resource_status: str = None, resource_id: str = None, external_resource_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The properties of a resource cost item.

  Parameters:

  - resourcename (str) – The name of the resource.
  - resource_uid (str) – The unique identifier of the resource.
  - resource_cost (float) – The cost component of the resource cost item.
  - resource_type (str) – The logical resource type (ex. virtualmachine, storageaccount)
  - resource_owner (str) – The owner of the resource (ex. janedoe@microsoft.com)
  - resource_pricing_tier (str) – The category of the resource (ex. Premium_LRS, Standard_DS1)
  - resource_status (str) – The status of the resource (ex. Active)
  - resource_id (str) – The ID of the resource
  - external_resource_id (str) – The ID of the external resource

class `azure.mgmt.devtestlabs.models.``LabSupportProperties`(*, enabled=None, markdown: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a lab’s support banner.

  Parameters:

  - enabled (str or EnableStatus) – Is the lab support banner active/enabled at this time?. Possible values include: ‘Enabled’, ‘Disabled’
  - markdown (str) – The markdown text (if any) that this lab displays in the UI. If left empty/null, nothing will be shown.

class `azure.mgmt.devtestlabs.models.``LabSupportPropertiesFragment`(*, enabled=None, markdown: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a lab’s support banner.

  Parameters:

  - enabled (str or EnableStatus) – Is the lab support banner active/enabled at this time?. Possible values include: ‘Enabled’, ‘Disabled’
  - markdown (str) – The markdown text (if any) that this lab displays in the UI. If left empty/null, nothing will be shown.

class `azure.mgmt.devtestlabs.models.``LabVhd`(*, id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a VHD in the lab.

  Parameters: | id (str) – The URI to the VHD.

class `azure.mgmt.devtestlabs.models.``LabVirtualMachine`(*, location: str = None, tags=None, notes: str = None, owner_object_id: str = None, owner_user_principal_name: str = None, created_by_user_id: str = None, created_by_user: str = None, created_date=None, compute_id: str = None, custom_image_id: str = None, os_type: str = None, size: str = None, user_name: str = None, password: str = None, ssh_key: str = None, is_authentication_with_ssh_key: bool = None, fqdn: str = None, lab_subnet_name: str = None, lab_virtual_network_id: str = None, disallow_public_ip_address: bool = None, artifacts=None, artifact_deployment_status=None, gallery_image_reference=None, plan_id: str = None, network_interface=None, expiration_date=None, allow_claim: bool = None, storage_type: str = None, virtual_machine_creation_source=None, environment_id: str = None, data_disk_parameters=None, schedule_parameters=None, last_known_power_state: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A virtual machine.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - compute_vm (ComputeVmProperties) – The compute virtual machine properties.
  - applicable_schedule (ApplicableSchedule) – The applicable schedule for the virtual machine.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - notes (str) – The notes of the virtual machine.
  - owner_object_id (str) – The object identifier of the owner of the virtual machine.
  - owner_user_principal_name (str) – The user principal name of the virtual machine owner.
  - created_by_user_id (str) – The object identifier of the creator of the virtual machine.
  - created_by_user (str) – The email address of creator of the virtual machine.
  - created_date (datetime) – The creation date of the virtual machine.
  - compute_id (str) – The resource identifier (Microsoft.Compute) of the virtual machine.
  - custom_image_id (str) – The custom image identifier of the virtual machine.
  - os_type (str) – The OS type of the virtual machine.
  - size (str) – The size of the virtual machine.
  - user_name (str) – The user name of the virtual machine.
  - password (str) – The password of the virtual machine administrator.
  - ssh_key (str) – The SSH key of the virtual machine administrator.
  - is_authentication_with_ssh_key (bool) – Indicates whether this virtual machine uses an SSH key for authentication.
  - fqdn (str) – The fully-qualified domain name of the virtual machine.
  - lab_subnet_name (str) – The lab subnet name of the virtual machine.
  - lab_virtual_network_id (str) – The lab virtual network identifier of the virtual machine.
  - disallow_public_ip_address (bool) – Indicates whether the virtual machine is to be created without a public IP address.
  - artifacts (list[ArtifactInstallProperties]) – The artifacts to be installed on the virtual machine.
  - artifact_deployment_status (ArtifactDeploymentStatusProperties) – The artifact deployment status for the virtual machine.
  - gallery_image_reference (GalleryImageReference) – The Microsoft Azure Marketplace image reference of the virtual machine.
  - plan_id (str) – The id of the plan associated with the virtual machine image
  - network_interface (NetworkInterfaceProperties) – The network interface properties.
  - expiration_date (datetime) – The expiration date for VM.
  - allow_claim (bool) – Indicates whether another user can take ownership of the virtual machine
  - storage_type (str) – Storage type to use for virtual machine (i.e. Standard, Premium).
  - virtual_machine_creation_source (str or VirtualMachineCreationSource) – Tells source of creation of lab virtual machine. Output property only. Possible values include: ‘FromCustomImage’, ‘FromGalleryImage’, ‘FromSharedGalleryImage’
  - environment_id (str) – The resource ID of the environment that contains this virtual machine, if any.
  - data_disk_parameters (list[DataDiskProperties]) – New or existing data disks to attach to the virtual machine after creation
  - schedule_parameters (list[ScheduleCreationParameter]) – Virtual Machine schedules to be created
  - last_known_power_state (str) – Last known compute power state captured in DTL

class `azure.mgmt.devtestlabs.models.``LabVirtualMachineCreationParameter`(*, bulk_creation_parameters=None, notes: str = None, owner_object_id: str = None, owner_user_principal_name: str = None, created_by_user_id: str = None, created_by_user: str = None, created_date=None, compute_id: str = None, custom_image_id: str = None, os_type: str = None, size: str = None, user_name: str = None, password: str = None, ssh_key: str = None, is_authentication_with_ssh_key: bool = None, fqdn: str = None, lab_subnet_name: str = None, lab_virtual_network_id: str = None, disallow_public_ip_address: bool = None, artifacts=None, artifact_deployment_status=None, gallery_image_reference=None, plan_id: str = None, network_interface=None, expiration_date=None, allow_claim: bool = None, storage_type: str = None, virtual_machine_creation_source=None, environment_id: str = None, data_disk_parameters=None, schedule_parameters=None, last_known_power_state: str = None, name: str = None, location: str = None, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a virtual machine.

  Parameters:

  - bulk_creation_parameters (BulkCreationParameters) – The number of virtual machine instances to create.
  - notes (str) – The notes of the virtual machine.
  - owner_object_id (str) – The object identifier of the owner of the virtual machine.
  - owner_user_principal_name (str) – The user principal name of the virtual machine owner.
  - created_by_user_id (str) – The object identifier of the creator of the virtual machine.
  - created_by_user (str) – The email address of creator of the virtual machine.
  - created_date (datetime) – The creation date of the virtual machine.
  - compute_id (str) – The resource identifier (Microsoft.Compute) of the virtual machine.
  - custom_image_id (str) – The custom image identifier of the virtual machine.
  - os_type (str) – The OS type of the virtual machine.
  - size (str) – The size of the virtual machine.
  - user_name (str) – The user name of the virtual machine.
  - password (str) – The password of the virtual machine administrator.
  - ssh_key (str) – The SSH key of the virtual machine administrator.
  - is_authentication_with_ssh_key (bool) – Indicates whether this virtual machine uses an SSH key for authentication.
  - fqdn (str) – The fully-qualified domain name of the virtual machine.
  - lab_subnet_name (str) – The lab subnet name of the virtual machine.
  - lab_virtual_network_id (str) – The lab virtual network identifier of the virtual machine.
  - disallow_public_ip_address (bool) – Indicates whether the virtual machine is to be created without a public IP address.
  - artifacts (list[ArtifactInstallProperties]) – The artifacts to be installed on the virtual machine.
  - artifact_deployment_status (ArtifactDeploymentStatusProperties) – The artifact deployment status for the virtual machine.
  - gallery_image_reference (GalleryImageReference) – The Microsoft Azure Marketplace image reference of the virtual machine.
  - plan_id (str) – The id of the plan associated with the virtual machine image
  - network_interface (NetworkInterfaceProperties) – The network interface properties.
  - expiration_date (datetime) – The expiration date for VM.
  - allow_claim (bool) – Indicates whether another user can take ownership of the virtual machine
  - storage_type (str) – Storage type to use for virtual machine (i.e. Standard, Premium).
  - virtual_machine_creation_source (str or VirtualMachineCreationSource) – Tells source of creation of lab virtual machine. Output property only. Possible values include: ‘FromCustomImage’, ‘FromGalleryImage’, ‘FromSharedGalleryImage’
  - environment_id (str) – The resource ID of the environment that contains this virtual machine, if any.
  - data_disk_parameters (list[DataDiskProperties]) – New or existing data disks to attach to the virtual machine after creation
  - schedule_parameters (list[ScheduleCreationParameter]) – Virtual Machine schedules to be created
  - last_known_power_state (str) – Last known compute power state captured in DTL
  - name (str) – The name of the virtual machine or environment
  - location (str) – The location of the new virtual machine or environment
  - tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``LabVirtualMachineCreationParameterFragment`(*, bulk_creation_parameters=None, notes: str = None, owner_object_id: str = None, owner_user_principal_name: str = None, created_by_user_id: str = None, created_by_user: str = None, created_date=None, compute_id: str = None, custom_image_id: str = None, os_type: str = None, size: str = None, user_name: str = None, password: str = None, ssh_key: str = None, is_authentication_with_ssh_key: bool = None, fqdn: str = None, lab_subnet_name: str = None, lab_virtual_network_id: str = None, disallow_public_ip_address: bool = None, artifacts=None, artifact_deployment_status=None, gallery_image_reference=None, plan_id: str = None, network_interface=None, expiration_date=None, allow_claim: bool = None, storage_type: str = None, virtual_machine_creation_source=None, environment_id: str = None, data_disk_parameters=None, schedule_parameters=None, last_known_power_state: str = None, name: str = None, location: str = None, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a virtual machine.

  Parameters:

  - bulk_creation_parameters (BulkCreationParametersFragment) – The number of virtual machine instances to create.
  - notes (str) – The notes of the virtual machine.
  - owner_object_id (str) – The object identifier of the owner of the virtual machine.
  - owner_user_principal_name (str) – The user principal name of the virtual machine owner.
  - created_by_user_id (str) – The object identifier of the creator of the virtual machine.
  - created_by_user (str) – The email address of creator of the virtual machine.
  - created_date (datetime) – The creation date of the virtual machine.
  - compute_id (str) – The resource identifier (Microsoft.Compute) of the virtual machine.
  - custom_image_id (str) – The custom image identifier of the virtual machine.
  - os_type (str) – The OS type of the virtual machine.
  - size (str) – The size of the virtual machine.
  - user_name (str) – The user name of the virtual machine.
  - password (str) – The password of the virtual machine administrator.
  - ssh_key (str) – The SSH key of the virtual machine administrator.
  - is_authentication_with_ssh_key (bool) – Indicates whether this virtual machine uses an SSH key for authentication.
  - fqdn (str) – The fully-qualified domain name of the virtual machine.
  - lab_subnet_name (str) – The lab subnet name of the virtual machine.
  - lab_virtual_network_id (str) – The lab virtual network identifier of the virtual machine.
  - disallow_public_ip_address (bool) – Indicates whether the virtual machine is to be created without a public IP address.
  - artifacts (list[ArtifactInstallPropertiesFragment]) – The artifacts to be installed on the virtual machine.
  - artifact_deployment_status (ArtifactDeploymentStatusPropertiesFragment) – The artifact deployment status for the virtual machine.
  - gallery_image_reference (GalleryImageReferenceFragment) – The Microsoft Azure Marketplace image reference of the virtual machine.
  - plan_id (str) – The id of the plan associated with the virtual machine image
  - network_interface (NetworkInterfacePropertiesFragment) – The network interface properties.
  - expiration_date (datetime) – The expiration date for VM.
  - allow_claim (bool) – Indicates whether another user can take ownership of the virtual machine
  - storage_type (str) – Storage type to use for virtual machine (i.e. Standard, Premium).
  - virtual_machine_creation_source (str or VirtualMachineCreationSource) – Tells source of creation of lab virtual machine. Output property only. Possible values include: ‘FromCustomImage’, ‘FromGalleryImage’, ‘FromSharedGalleryImage’
  - environment_id (str) – The resource ID of the environment that contains this virtual machine, if any.
  - data_disk_parameters (list[DataDiskPropertiesFragment]) – New or existing data disks to attach to the virtual machine after creation
  - schedule_parameters (list[ScheduleCreationParameterFragment]) – Virtual Machine schedules to be created
  - last_known_power_state (str) – Last known compute power state captured in DTL
  - name (str) – The name of the virtual machine or environment
  - location (str) – The location of the new virtual machine or environment
  - tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``LabVirtualMachineFragment`(*, tags=None, notes: str = None, owner_object_id: str = None, owner_user_principal_name: str = None, created_by_user_id: str = None, created_by_user: str = None, created_date=None, compute_id: str = None, custom_image_id: str = None, os_type: str = None, size: str = None, user_name: str = None, password: str = None, ssh_key: str = None, is_authentication_with_ssh_key: bool = None, fqdn: str = None, lab_subnet_name: str = None, lab_virtual_network_id: str = None, disallow_public_ip_address: bool = None, artifacts=None, artifact_deployment_status=None, gallery_image_reference=None, plan_id: str = None, network_interface=None, expiration_date=None, allow_claim: bool = None, storage_type: str = None, virtual_machine_creation_source=None, environment_id: str = None, data_disk_parameters=None, schedule_parameters=None, last_known_power_state: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A virtual machine.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - notes (str) – The notes of the virtual machine.
  - owner_object_id (str) – The object identifier of the owner of the virtual machine.
  - owner_user_principal_name (str) – The user principal name of the virtual machine owner.
  - created_by_user_id (str) – The object identifier of the creator of the virtual machine.
  - created_by_user (str) – The email address of creator of the virtual machine.
  - created_date (datetime) – The creation date of the virtual machine.
  - compute_id (str) – The resource identifier (Microsoft.Compute) of the virtual machine.
  - custom_image_id (str) – The custom image identifier of the virtual machine.
  - os_type (str) – The OS type of the virtual machine.
  - size (str) – The size of the virtual machine.
  - user_name (str) – The user name of the virtual machine.
  - password (str) – The password of the virtual machine administrator.
  - ssh_key (str) – The SSH key of the virtual machine administrator.
  - is_authentication_with_ssh_key (bool) – Indicates whether this virtual machine uses an SSH key for authentication.
  - fqdn (str) – The fully-qualified domain name of the virtual machine.
  - lab_subnet_name (str) – The lab subnet name of the virtual machine.
  - lab_virtual_network_id (str) – The lab virtual network identifier of the virtual machine.
  - disallow_public_ip_address (bool) – Indicates whether the virtual machine is to be created without a public IP address.
  - artifacts (list[ArtifactInstallPropertiesFragment]) – The artifacts to be installed on the virtual machine.
  - artifact_deployment_status (ArtifactDeploymentStatusPropertiesFragment) – The artifact deployment status for the virtual machine.
  - gallery_image_reference (GalleryImageReferenceFragment) – The Microsoft Azure Marketplace image reference of the virtual machine.
  - plan_id (str) – The id of the plan associated with the virtual machine image
  - network_interface (NetworkInterfacePropertiesFragment) – The network interface properties.
  - expiration_date (datetime) – The expiration date for VM.
  - allow_claim (bool) – Indicates whether another user can take ownership of the virtual machine
  - storage_type (str) – Storage type to use for virtual machine (i.e. Standard, Premium).
  - virtual_machine_creation_source (str or VirtualMachineCreationSource) – Tells source of creation of lab virtual machine. Output property only. Possible values include: ‘FromCustomImage’, ‘FromGalleryImage’, ‘FromSharedGalleryImage’
  - environment_id (str) – The resource ID of the environment that contains this virtual machine, if any.
  - data_disk_parameters (list[DataDiskPropertiesFragment]) – New or existing data disks to attach to the virtual machine after creation
  - schedule_parameters (list[ScheduleCreationParameterFragment]) – Virtual Machine schedules to be created
  - last_known_power_state (str) – Last known compute power state captured in DTL

class `azure.mgmt.devtestlabs.models.``LinuxOsInfo`(*, linux_os_state=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about a Linux OS.

  Parameters: | linux_os_state (str or LinuxOsState) – The state of the Linux OS (i.e. NonDeprovisioned, DeprovisionRequested, DeprovisionApplied). Possible values include: ‘NonDeprovisioned’, ‘DeprovisionRequested’, ‘DeprovisionApplied’

class `azure.mgmt.devtestlabs.models.``LinuxOsInfoFragment`(*, linux_os_state=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about a Linux OS.

  Parameters: | linux_os_state (str or LinuxOsState) – The state of the Linux OS (i.e. NonDeprovisioned, DeprovisionRequested, DeprovisionApplied). Possible values include: ‘NonDeprovisioned’, ‘DeprovisionRequested’, ‘DeprovisionApplied’

class `azure.mgmt.devtestlabs.models.``NetworkInterfaceProperties`(*, virtual_network_id: str = None, subnet_id: str = None, public_ip_address_id: str = None, public_ip_address: str = None, private_ip_address: str = None, dns_name: str = None, rdp_authority: str = None, ssh_authority: str = None, shared_public_ip_address_configuration=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a network interface.

  Parameters:

  - virtual_network_id (str) – The resource ID of the virtual network.
  - subnet_id (str) – The resource ID of the sub net.
  - public_ip_address_id (str) – The resource ID of the public IP address.
  - public_ip_address (str) – The public IP address.
  - private_ip_address (str) – The private IP address.
  - dns_name (str) – The DNS name.
  - rdp_authority (str) – The RdpAuthority property is a server DNS host name or IP address followed by the service port number for RDP (Remote Desktop Protocol).
  - ssh_authority (str) – The SshAuthority property is a server DNS host name or IP address followed by the service port number for SSH.
  - shared_public_ip_address_configuration (SharedPublicIpAddressConfiguration) – The configuration for sharing a public IP address across multiple virtual machines.

class `azure.mgmt.devtestlabs.models.``NetworkInterfacePropertiesFragment`(*, virtual_network_id: str = None, subnet_id: str = None, public_ip_address_id: str = None, public_ip_address: str = None, private_ip_address: str = None, dns_name: str = None, rdp_authority: str = None, ssh_authority: str = None, shared_public_ip_address_configuration=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a network interface.

  Parameters:

  - virtual_network_id (str) – The resource ID of the virtual network.
  - subnet_id (str) – The resource ID of the sub net.
  - public_ip_address_id (str) – The resource ID of the public IP address.
  - public_ip_address (str) – The public IP address.
  - private_ip_address (str) – The private IP address.
  - dns_name (str) – The DNS name.
  - rdp_authority (str) – The RdpAuthority property is a server DNS host name or IP address followed by the service port number for RDP (Remote Desktop Protocol).
  - ssh_authority (str) – The SshAuthority property is a server DNS host name or IP address followed by the service port number for SSH.
  - shared_public_ip_address_configuration (SharedPublicIpAddressConfigurationFragment) – The configuration for sharing a public IP address across multiple virtual machines.

class `azure.mgmt.devtestlabs.models.``NotificationChannel`(*, location: str = None, tags=None, web_hook_url: str = None, email_recipient: str = None, notification_locale: str = None, description: str = None, events=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A notification.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - created_date (datetime) – The creation date of the notification channel.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - web_hook_url (str) – The webhook URL to send notifications to.
  - email_recipient (str) – The email recipient to send notifications to (can be a list of semi-colon separated email addresses).
  - notification_locale (str) – The locale to use when sending a notification (fallback for unsupported languages is EN).
  - description (str) – Description of notification.
  - events (list[Event]) – The list of event for which this notification is enabled.

class `azure.mgmt.devtestlabs.models.``NotificationChannelFragment`(*, tags=None, web_hook_url: str = None, email_recipient: str = None, notification_locale: str = None, description: str = None, events=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A notification.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - web_hook_url (str) – The webhook URL to send notifications to.
  - email_recipient (str) – The email recipient to send notifications to (can be a list of semi-colon separated email addresses).
  - notification_locale (str) – The locale to use when sending a notification (fallback for unsupported languages is EN).
  - description (str) – Description of notification.
  - events (list[EventFragment]) – The list of event for which this notification is enabled.

class `azure.mgmt.devtestlabs.models.``NotificationSettings`(*, status=None, time_in_minutes: int = None, webhook_url: str = None, email_recipient: str = None, notification_locale: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Notification settings for a schedule.

  Parameters:

  - status (str or EnableStatus) – If notifications are enabled for this schedule (i.e. Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’
  - time_in_minutes (int) – Time in minutes before event at which notification will be sent.
  - webhook_url (str) – The webhook URL to which the notification will be sent.
  - email_recipient (str) – The email recipient to send notifications to (can be a list of semi-colon separated email addresses).
  - notification_locale (str) – The locale to use when sending a notification (fallback for unsupported languages is EN).

class `azure.mgmt.devtestlabs.models.``NotificationSettingsFragment`(*, status=None, time_in_minutes: int = None, webhook_url: str = None, email_recipient: str = None, notification_locale: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Notification settings for a schedule.

  Parameters:

  - status (str or EnableStatus) – If notifications are enabled for this schedule (i.e. Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’
  - time_in_minutes (int) – Time in minutes before event at which notification will be sent.
  - webhook_url (str) – The webhook URL to which the notification will be sent.
  - email_recipient (str) – The email recipient to send notifications to (can be a list of semi-colon separated email addresses).
  - notification_locale (str) – The locale to use when sending a notification (fallback for unsupported languages is EN).

class `azure.mgmt.devtestlabs.models.``NotifyParameters`(*, event_name=None, json_payload: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for generating a Notification.

  Parameters:

  - event_name (str or NotificationChannelEventType) – The type of event (i.e. AutoShutdown, Cost). Possible values include: ‘AutoShutdown’, ‘Cost’
  - json_payload (str) – Properties for the notification in json format.

class `azure.mgmt.devtestlabs.models.``OperationError`(*, code: str = None, message: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Error details for the operation in case of a failure.

  Parameters:

  - code (str) – The error code of the operation error.
  - message (str) – The error message of the operation error.

class `azure.mgmt.devtestlabs.models.``OperationMetadata`(*, name: str = None, display=None, **kwargs)

  Bases: `msrest.serialization.Model`

  The REST API operation supported by DevTestLab ResourceProvider.

  Parameters:

  - name (str) – Operation name: {provider}/{resource}/{operation}
  - display (OperationMetadataDisplay) – The object that describes the operations

class `azure.mgmt.devtestlabs.models.``OperationMetadataDisplay`(*, provider: str = None, resource: str = None, operation: str = None, description: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The object that describes the operations.

  Parameters:

  - provider (str) – Friendly name of the resource provider
  - resource (str) – Resource type on which the operation is performed.
  - operation (str) – Operation type: read, write, delete, listKeys/action, etc.
  - description (str) – Friendly name of the operation

class `azure.mgmt.devtestlabs.models.``OperationResult`(*, status: str = None, status_code=None, error=None, **kwargs)

  Bases: `msrest.serialization.Model`

  An Operation Result.

  Parameters:

  - status (str) – The operation status.
  - status_code (str or HttpStatusCode) – The status code for the operation. Possible values include: ‘Continue’, ‘SwitchingProtocols’, ‘OK’, ‘Created’, ‘Accepted’, ‘NonAuthoritativeInformation’, ‘NoContent’, ‘ResetContent’, ‘PartialContent’, ‘MultipleChoices’, ‘MovedPermanently’, ‘Redirect’, ‘SeeOther’, ‘NotModified’, ‘UseProxy’, ‘Unused’, ‘TemporaryRedirect’, ‘BadRequest’, ‘Unauthorized’, ‘PaymentRequired’, ‘Forbidden’, ‘NotFound’, ‘MethodNotAllowed’, ‘NotAcceptable’, ‘ProxyAuthenticationRequired’, ‘RequestTimeout’, ‘Conflict’, ‘Gone’, ‘LengthRequired’, ‘PreconditionFailed’, ‘RequestEntityTooLarge’, ‘RequestUriTooLong’, ‘UnsupportedMediaType’, ‘RequestedRangeNotSatisfiable’, ‘ExpectationFailed’, ‘UpgradeRequired’, ‘InternalServerError’, ‘NotImplemented’, ‘BadGateway’, ‘ServiceUnavailable’, ‘GatewayTimeout’, ‘HttpVersionNotSupported’
  - error (OperationError) – Error details for the operation in case of a failure.

class `azure.mgmt.devtestlabs.models.``ParameterInfo`(*, name: str = None, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about an artifact’s parameter.

  Parameters:

  - name (str) – The name of the artifact parameter.
  - value (str) – The value of the artifact parameter.

class `azure.mgmt.devtestlabs.models.``ParametersValueFileInfo`(*, file_name: str = None, parameters_value_info=None, **kwargs)

  Bases: `msrest.serialization.Model`

  A file containing a set of parameter values for an ARM template.

  Parameters:

  - file_name (str) – File name.
  - parameters_value_info (object) – Contents of the file.

class `azure.mgmt.devtestlabs.models.``PercentageCostThresholdProperties`(*, threshold_value: float = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a percentage cost threshold.

  Parameters: | threshold_value (float) – The cost threshold value.

class `azure.mgmt.devtestlabs.models.``Policy`(*, location: str = None, tags=None, description: str = None, status=None, fact_name=None, fact_data: str = None, threshold: str = None, evaluator_type=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A Policy.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - created_date (datetime) – The creation date of the policy.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - description (str) – The description of the policy.
  - status (str or PolicyStatus) – The status of the policy. Possible values include: ‘Enabled’, ‘Disabled’
  - fact_name (str or PolicyFactName) – The fact name of the policy (e.g. LabVmCount, LabVmSize, MaxVmsAllowedPerLab, etc. Possible values include: ‘UserOwnedLabVmCount’, ‘UserOwnedLabPremiumVmCount’, ‘LabVmCount’, ‘LabPremiumVmCount’, ‘LabVmSize’, ‘GalleryImage’, ‘UserOwnedLabVmCountInSubnet’, ‘LabTargetCost’, ‘EnvironmentTemplate’, ‘ScheduleEditPermission’
  - fact_data (str) – The fact data of the policy.
  - threshold (str) – The threshold of the policy (i.e. a number for MaxValuePolicy, and a JSON array of values for AllowedValuesPolicy).
  - evaluator_type (str or PolicyEvaluatorType) – The evaluator type of the policy (i.e. AllowedValuesPolicy, MaxValuePolicy). Possible values include: ‘AllowedValuesPolicy’, ‘MaxValuePolicy’

class `azure.mgmt.devtestlabs.models.``PolicyFragment`(*, tags=None, description: str = None, status=None, fact_name=None, fact_data: str = None, threshold: str = None, evaluator_type=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A Policy.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - description (str) – The description of the policy.
  - status (str or PolicyStatus) – The status of the policy. Possible values include: ‘Enabled’, ‘Disabled’
  - fact_name (str or PolicyFactName) – The fact name of the policy (e.g. LabVmCount, LabVmSize, MaxVmsAllowedPerLab, etc. Possible values include: ‘UserOwnedLabVmCount’, ‘UserOwnedLabPremiumVmCount’, ‘LabVmCount’, ‘LabPremiumVmCount’, ‘LabVmSize’, ‘GalleryImage’, ‘UserOwnedLabVmCountInSubnet’, ‘LabTargetCost’, ‘EnvironmentTemplate’, ‘ScheduleEditPermission’
  - fact_data (str) – The fact data of the policy.
  - threshold (str) – The threshold of the policy (i.e. a number for MaxValuePolicy, and a JSON array of values for AllowedValuesPolicy).
  - evaluator_type (str or PolicyEvaluatorType) – The evaluator type of the policy (i.e. AllowedValuesPolicy, MaxValuePolicy). Possible values include: ‘AllowedValuesPolicy’, ‘MaxValuePolicy’

class `azure.mgmt.devtestlabs.models.``PolicySetResult`(*, has_error: bool = None, policy_violations=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Result of a policy set evaluation.

  Parameters:

  - has_error (bool) – A value indicating whether this policy set evaluation has discovered violations.
  - policy_violations (list[PolicyViolation]) – The list of policy violations.

class `azure.mgmt.devtestlabs.models.``PolicyViolation`(*, code: str = None, message: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Policy violation.

  Parameters:

  - code (str) – The code of the policy violation.
  - message (str) – The message of the policy violation.

class `azure.mgmt.devtestlabs.models.``Port`(*, transport_protocol=None, backend_port: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a network port.

  Parameters:

  - transport_protocol (str or TransportProtocol) – Protocol type of the port. Possible values include: ‘Tcp’, ‘Udp’
  - backend_port (int) – Backend port of the target virtual machine.

class `azure.mgmt.devtestlabs.models.``PortFragment`(*, transport_protocol=None, backend_port: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a network port.

  Parameters:

  - transport_protocol (str or TransportProtocol) – Protocol type of the port. Possible values include: ‘Tcp’, ‘Udp’
  - backend_port (int) – Backend port of the target virtual machine.

class `azure.mgmt.devtestlabs.models.``RdpConnection`(*, contents: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Represents a .rdp file.

  Parameters: | contents (str) – The contents of the .rdp file

class `azure.mgmt.devtestlabs.models.``ResizeLabVirtualMachineProperties`(*, size: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Request body for resizing a virtual machine.

  Parameters: | size (str) – Specifies the size of the virtual machine.

class `azure.mgmt.devtestlabs.models.``Resource`(*, location: str = None, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  An Azure resource.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``RetargetScheduleProperties`(*, current_resource_id: str = None, target_resource_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for retargeting a virtual machine schedule.

  Parameters:

  - current_resource_id (str) – The resource Id of the virtual machine on which the schedule operates
  - target_resource_id (str) – The resource Id of the virtual machine that the schedule should be retargeted to

class `azure.mgmt.devtestlabs.models.``Schedule`(*, location: str = None, tags=None, status=None, task_type: str = None, weekly_recurrence=None, daily_recurrence=None, hourly_recurrence=None, time_zone_id: str = None, notification_settings=None, target_resource_id: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A schedule.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - created_date (datetime) – The creation date of the schedule.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - status (str or EnableStatus) – The status of the schedule (i.e. Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’
  - task_type (str) – The task type of the schedule (e.g. LabVmsShutdownTask, LabVmAutoStart).
  - weekly_recurrence (WeekDetails) – If the schedule will occur only some days of the week, specify the weekly recurrence.
  - daily_recurrence (DayDetails) – If the schedule will occur once each day of the week, specify the daily recurrence.
  - hourly_recurrence (HourDetails) – If the schedule will occur multiple times a day, specify the hourly recurrence.
  - time_zone_id (str) – The time zone ID (e.g. Pacific Standard time).
  - notification_settings (NotificationSettings) – Notification settings.
  - target_resource_id (str) – The resource ID to which the schedule belongs

class `azure.mgmt.devtestlabs.models.``ScheduleCreationParameter`(*, status=None, task_type: str = None, weekly_recurrence=None, daily_recurrence=None, hourly_recurrence=None, time_zone_id: str = None, notification_settings=None, target_resource_id: str = None, name: str = None, location: str = None, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a schedule.

  Parameters:

  - status (str or EnableStatus) – The status of the schedule (i.e. Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’
  - task_type (str) – The task type of the schedule (e.g. LabVmsShutdownTask, LabVmAutoStart).
  - weekly_recurrence (WeekDetails) – If the schedule will occur only some days of the week, specify the weekly recurrence.
  - daily_recurrence (DayDetails) – If the schedule will occur once each day of the week, specify the daily recurrence.
  - hourly_recurrence (HourDetails) – If the schedule will occur multiple times a day, specify the hourly recurrence.
  - time_zone_id (str) – The time zone ID (e.g. Pacific Standard time).
  - notification_settings (NotificationSettings) – Notification settings.
  - target_resource_id (str) – The resource ID to which the schedule belongs
  - name (str) – The name of the virtual machine or environment
  - location (str) – The location of the new virtual machine or environment
  - tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``ScheduleCreationParameterFragment`(*, status=None, task_type: str = None, weekly_recurrence=None, daily_recurrence=None, hourly_recurrence=None, time_zone_id: str = None, notification_settings=None, target_resource_id: str = None, name: str = None, location: str = None, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties for creating a schedule.

  Parameters:

  - status (str or EnableStatus) – The status of the schedule (i.e. Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’
  - task_type (str) – The task type of the schedule (e.g. LabVmsShutdownTask, LabVmAutoStart).
  - weekly_recurrence (WeekDetailsFragment) – If the schedule will occur only some days of the week, specify the weekly recurrence.
  - daily_recurrence (DayDetailsFragment) – If the schedule will occur once each day of the week, specify the daily recurrence.
  - hourly_recurrence (HourDetailsFragment) – If the schedule will occur multiple times a day, specify the hourly recurrence.
  - time_zone_id (str) – The time zone ID (e.g. Pacific Standard time).
  - notification_settings (NotificationSettingsFragment) – Notification settings.
  - target_resource_id (str) – The resource ID to which the schedule belongs
  - name (str) – The name of the virtual machine or environment
  - location (str) – The location of the new virtual machine or environment
  - tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``ScheduleFragment`(*, tags=None, status=None, task_type: str = None, weekly_recurrence=None, daily_recurrence=None, hourly_recurrence=None, time_zone_id: str = None, notification_settings=None, target_resource_id: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A schedule.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - status (str or EnableStatus) – The status of the schedule (i.e. Enabled, Disabled). Possible values include: ‘Enabled’, ‘Disabled’
  - task_type (str) – The task type of the schedule (e.g. LabVmsShutdownTask, LabVmAutoStart).
  - weekly_recurrence (WeekDetailsFragment) – If the schedule will occur only some days of the week, specify the weekly recurrence.
  - daily_recurrence (DayDetailsFragment) – If the schedule will occur once each day of the week, specify the daily recurrence.
  - hourly_recurrence (HourDetailsFragment) – If the schedule will occur multiple times a day, specify the hourly recurrence.
  - time_zone_id (str) – The time zone ID (e.g. Pacific Standard time).
  - notification_settings (NotificationSettingsFragment) – Notification settings.
  - target_resource_id (str) – The resource ID to which the schedule belongs

class `azure.mgmt.devtestlabs.models.``Secret`(*, location: str = None, tags=None, value: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A secret.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - value (str) – The value of the secret for secret creation.

class `azure.mgmt.devtestlabs.models.``SecretFragment`(*, tags=None, value: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A secret.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - value (str) – The value of the secret for secret creation.

class `azure.mgmt.devtestlabs.models.``ServiceFabric`(*, location: str = None, tags=None, external_service_fabric_id: str = None, environment_id: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A Service Fabric.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - applicable_schedule (ApplicableSchedule) – The applicable schedule for the virtual machine.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - external_service_fabric_id (str) – The backing service fabric resource’s id
  - environment_id (str) – The resource id of the environment under which the service fabric resource is present

class `azure.mgmt.devtestlabs.models.``ServiceFabricFragment`(*, tags=None, external_service_fabric_id: str = None, environment_id: str = None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A Service Fabric.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - external_service_fabric_id (str) – The backing service fabric resource’s id
  - environment_id (str) – The resource id of the environment under which the service fabric resource is present

class `azure.mgmt.devtestlabs.models.``ServiceRunner`(*, location: str = None, tags=None, identity=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A container for a managed identity to execute DevTest lab services.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - identity (IdentityProperties) – The identity of the resource.

class `azure.mgmt.devtestlabs.models.``SharedPublicIpAddressConfiguration`(*, inbound_nat_rules=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a virtual machine that determine how it is connected to a load balancer.

  Parameters: | inbound_nat_rules (list[InboundNatRule]) – The incoming NAT rules

class `azure.mgmt.devtestlabs.models.``SharedPublicIpAddressConfigurationFragment`(*, inbound_nat_rules=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a virtual machine that determine how it is connected to a load balancer.

  Parameters: | inbound_nat_rules (list[InboundNatRuleFragment]) – The incoming NAT rules

class `azure.mgmt.devtestlabs.models.``ShutdownNotificationContent`(*, skip_url: str = None, delay_url60: str = None, delay_url120: str = None, vm_name: str = None, guid: str = None, owner: str = None, vm_url: str = None, minutes_until_shutdown: str = None, event_type: str = None, text: str = None, subscription_id: str = None, resource_group_name: str = None, lab_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The contents of a shutdown notification. Webhooks can use this type to deserialize the request body when they get notified of an imminent shutdown.

  Parameters:

  - skip_url (str) – The URL to skip auto-shutdown.
  - delay_url60 (str) – The URL to delay shutdown by 60 minutes.
  - delay_url120 (str) – The URL to delay shutdown by 2 hours.
  - vm_name (str) – The virtual machine to be shut down.
  - guid (str) – The GUID for the virtual machine to be shut down.
  - owner (str) – The owner of the virtual machine.
  - vm_url (str) – The URL of the virtual machine.
  - minutes_until_shutdown (str) – Minutes remaining until shutdown
  - event_type (str) – The event for which a notification will be sent.
  - text (str) – The text for the notification.
  - subscription_id (str) – The subscription ID for the schedule.
  - resource_group_name (str) – The resource group name for the schedule.
  - lab_name (str) – The lab for the schedule.

class `azure.mgmt.devtestlabs.models.``Subnet`(*, resource_id: str = None, lab_subnet_name: str = None, allow_public_ip=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subnet information.

  Parameters:

  - resource_id (str) – The resource ID of the subnet.
  - lab_subnet_name (str) – The name of the subnet as seen in the lab.
  - allow_public_ip (str or UsagePermissionType) – The permission policy of the subnet for allowing public IP addresses (i.e. Allow, Deny)). Possible values include: ‘Default’, ‘Deny’, ‘Allow’

class `azure.mgmt.devtestlabs.models.``SubnetFragment`(*, resource_id: str = None, lab_subnet_name: str = None, allow_public_ip=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Subnet information.

  Parameters:

  - resource_id (str) – The resource ID of the subnet.
  - lab_subnet_name (str) – The name of the subnet as seen in the lab.
  - allow_public_ip (str or UsagePermissionType) – The permission policy of the subnet for allowing public IP addresses (i.e. Allow, Deny)). Possible values include: ‘Default’, ‘Deny’, ‘Allow’

class `azure.mgmt.devtestlabs.models.``SubnetOverride`(*, resource_id: str = None, lab_subnet_name: str = None, use_in_vm_creation_permission=None, use_public_ip_address_permission=None, shared_public_ip_address_configuration=None, virtual_network_pool_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Property overrides on a subnet of a virtual network.

  Parameters:

  - resource_id (str) – The resource ID of the subnet.
  - lab_subnet_name (str) – The name given to the subnet within the lab.
  - use_in_vm_creation_permission (str or UsagePermissionType) – Indicates whether this subnet can be used during virtual machine creation (i.e. Allow, Deny). Possible values include: ‘Default’, ‘Deny’, ‘Allow’
  - use_public_ip_address_permission (str or UsagePermissionType) – Indicates whether public IP addresses can be assigned to virtual machines on this subnet (i.e. Allow, Deny). Possible values include: ‘Default’, ‘Deny’, ‘Allow’
  - shared_public_ip_address_configuration (SubnetSharedPublicIpAddressConfiguration) – Properties that virtual machines on this subnet will share.
  - virtual_network_pool_name (str) – The virtual network pool associated with this subnet.

class `azure.mgmt.devtestlabs.models.``SubnetOverrideFragment`(*, resource_id: str = None, lab_subnet_name: str = None, use_in_vm_creation_permission=None, use_public_ip_address_permission=None, shared_public_ip_address_configuration=None, virtual_network_pool_name: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Property overrides on a subnet of a virtual network.

  Parameters:

  - resource_id (str) – The resource ID of the subnet.
  - lab_subnet_name (str) – The name given to the subnet within the lab.
  - use_in_vm_creation_permission (str or UsagePermissionType) – Indicates whether this subnet can be used during virtual machine creation (i.e. Allow, Deny). Possible values include: ‘Default’, ‘Deny’, ‘Allow’
  - use_public_ip_address_permission (str or UsagePermissionType) – Indicates whether public IP addresses can be assigned to virtual machines on this subnet (i.e. Allow, Deny). Possible values include: ‘Default’, ‘Deny’, ‘Allow’
  - shared_public_ip_address_configuration (SubnetSharedPublicIpAddressConfigurationFragment) – Properties that virtual machines on this subnet will share.
  - virtual_network_pool_name (str) – The virtual network pool associated with this subnet.

class `azure.mgmt.devtestlabs.models.``SubnetSharedPublicIpAddressConfiguration`(*, allowed_ports=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Configuration for public IP address sharing.

  Parameters: | allowed_ports (list[Port]) – Backend ports that virtual machines on this subnet are allowed to expose

class `azure.mgmt.devtestlabs.models.``SubnetSharedPublicIpAddressConfigurationFragment`(*, allowed_ports=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Configuration for public IP address sharing.

  Parameters: | allowed_ports (list[PortFragment]) – Backend ports that virtual machines on this subnet are allowed to expose

class `azure.mgmt.devtestlabs.models.``TargetCostProperties`(*, status=None, target: int = None, cost_thresholds=None, cycle_start_date_time=None, cycle_end_date_time=None, cycle_type=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a cost target.

  Parameters:

  - status (str or TargetCostStatus) – Target cost status. Possible values include: ‘Enabled’, ‘Disabled’
  - target (int) – Lab target cost
  - cost_thresholds (list[CostThresholdProperties]) – Cost thresholds.
  - cycle_start_date_time (datetime) – Reporting cycle start date.
  - cycle_end_date_time (datetime) – Reporting cycle end date.
  - cycle_type (str or ReportingCycleType) – Reporting cycle type. Possible values include: ‘CalendarMonth’, ‘Custom’

class `azure.mgmt.devtestlabs.models.``UpdateResource`(*, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Represents an update resource.

  Parameters: | tags (dict[str, str]) – The tags of the resource.

class `azure.mgmt.devtestlabs.models.``User`(*, location: str = None, tags=None, identity=None, secret_store=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  Profile of a lab user.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - created_date (datetime) – The creation date of the user profile.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - identity (UserIdentity) – The identity of the user.
  - secret_store (UserSecretStore) – The secret store of the user.

class `azure.mgmt.devtestlabs.models.``UserFragment`(*, tags=None, identity=None, secret_store=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  Profile of a lab user.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - identity (UserIdentityFragment) – The identity of the user.
  - secret_store (UserSecretStoreFragment) – The secret store of the user.

class `azure.mgmt.devtestlabs.models.``UserIdentity`(*, principal_name: str = None, principal_id: str = None, tenant_id: str = None, object_id: str = None, app_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Identity attributes of a lab user.

  Parameters:

  - principal_name (str) – Set to the principal name / UPN of the client JWT making the request.
  - principal_id (str) – Set to the principal Id of the client JWT making the request. Service principal will not have the principal Id.
  - tenant_id (str) – Set to the tenant ID of the client JWT making the request.
  - object_id (str) – Set to the object Id of the client JWT making the request. Not all users have object Id. For CSP (reseller) scenarios for example, object Id is not available.
  - app_id (str) – Set to the app Id of the client JWT making the request.

class `azure.mgmt.devtestlabs.models.``UserIdentityFragment`(*, principal_name: str = None, principal_id: str = None, tenant_id: str = None, object_id: str = None, app_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Identity attributes of a lab user.

  Parameters:

  - principal_name (str) – Set to the principal name / UPN of the client JWT making the request.
  - principal_id (str) – Set to the principal Id of the client JWT making the request. Service principal will not have the principal Id.
  - tenant_id (str) – Set to the tenant ID of the client JWT making the request.
  - object_id (str) – Set to the object Id of the client JWT making the request. Not all users have object Id. For CSP (reseller) scenarios for example, object Id is not available.
  - app_id (str) – Set to the app Id of the client JWT making the request.

class `azure.mgmt.devtestlabs.models.``UserSecretStore`(*, key_vault_uri: str = None, key_vault_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a user’s secret store.

  Parameters:

  - key_vault_uri (str) – The URI of the user’s Key vault.
  - key_vault_id (str) – The ID of the user’s Key vault.

class `azure.mgmt.devtestlabs.models.``UserSecretStoreFragment`(*, key_vault_uri: str = None, key_vault_id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a user’s secret store.

  Parameters:

  - key_vault_uri (str) – The URI of the user’s Key vault.
  - key_vault_id (str) – The ID of the user’s Key vault.

class `azure.mgmt.devtestlabs.models.``VirtualNetwork`(*, location: str = None, tags=None, allowed_subnets=None, description: str = None, external_provider_resource_id: str = None, subnet_overrides=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.Resource`

  A virtual network.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The identifier of the resource.
  - name (str) – The name of the resource.
  - type (str) – The type of the resource.
  - external_subnets (list[ExternalSubnet]) – The external subnet properties.
  - created_date (datetime) – The creation date of the virtual network.
  - provisioning_state (str) – The provisioning status of the resource.
  - unique_identifier (str) – The unique immutable identifier of a resource (Guid).

  Parameters:

  - location (str) – The location of the resource.
  - tags (dict[str, str]) – The tags of the resource.
  - allowed_subnets (list[Subnet]) – The allowed subnets of the virtual network.
  - description (str) – The description of the virtual network.
  - external_provider_resource_id (str) – The Microsoft.Network resource identifier of the virtual network.
  - subnet_overrides (list[SubnetOverride]) – The subnet overrides of the virtual network.

class `azure.mgmt.devtestlabs.models.``VirtualNetworkFragment`(*, tags=None, allowed_subnets=None, description: str = None, external_provider_resource_id: str = None, subnet_overrides=None, **kwargs)

  Bases: `azure.mgmt.devtestlabs.models._models_py3.UpdateResource`

  A virtual network.

  Parameters:

  - tags (dict[str, str]) – The tags of the resource.
  - allowed_subnets (list[SubnetFragment]) – The allowed subnets of the virtual network.
  - description (str) – The description of the virtual network.
  - external_provider_resource_id (str) – The Microsoft.Network resource identifier of the virtual network.
  - subnet_overrides (list[SubnetOverrideFragment]) – The subnet overrides of the virtual network.

class `azure.mgmt.devtestlabs.models.``WeekDetails`(*, weekdays=None, time: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a weekly schedule.

  Parameters:

  - weekdays (list[str]) – The days of the week for which the schedule is set (e.g. Sunday, Monday, Tuesday, etc.).
  - time (str) – The time of the day the schedule will occur.

class `azure.mgmt.devtestlabs.models.``WeekDetailsFragment`(*, weekdays=None, time: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties of a weekly schedule.

  Parameters:

  - weekdays (list[str]) – The days of the week for which the schedule is set (e.g. Sunday, Monday, Tuesday, etc.).
  - time (str) – The time of the day the schedule will occur.

class `azure.mgmt.devtestlabs.models.``WindowsOsInfo`(*, windows_os_state=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about a Windows OS.

  Parameters: | windows_os_state (str or WindowsOsState) – The state of the Windows OS (i.e. NonSysprepped, SysprepRequested, SysprepApplied). Possible values include: ‘NonSysprepped’, ‘SysprepRequested’, ‘SysprepApplied’

class `azure.mgmt.devtestlabs.models.``WindowsOsInfoFragment`(*, windows_os_state=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Information about a Windows OS.

  Parameters: | windows_os_state (str or WindowsOsState) – The state of the Windows OS (i.e. NonSysprepped, SysprepRequested, SysprepApplied). Possible values include: ‘NonSysprepped’, ‘SysprepRequested’, ‘SysprepApplied’

class `azure.mgmt.devtestlabs.models.``OperationMetadataPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `OperationMetadata` object

class `azure.mgmt.devtestlabs.models.``LabPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Lab` object

class `azure.mgmt.devtestlabs.models.``LabVhdPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `LabVhd` object

class `azure.mgmt.devtestlabs.models.``SchedulePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Schedule` object

class `azure.mgmt.devtestlabs.models.``ArtifactSourcePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ArtifactSource` object

class `azure.mgmt.devtestlabs.models.``ArmTemplatePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ArmTemplate` object

class `azure.mgmt.devtestlabs.models.``ArtifactPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Artifact` object

class `azure.mgmt.devtestlabs.models.``CustomImagePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `CustomImage` object

class `azure.mgmt.devtestlabs.models.``FormulaPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Formula` object

class `azure.mgmt.devtestlabs.models.``GalleryImagePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `GalleryImage` object

class `azure.mgmt.devtestlabs.models.``NotificationChannelPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `NotificationChannel` object

class `azure.mgmt.devtestlabs.models.``PolicyPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Policy` object

class `azure.mgmt.devtestlabs.models.``UserPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `User` object

class `azure.mgmt.devtestlabs.models.``DiskPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Disk` object

class `azure.mgmt.devtestlabs.models.``DtlEnvironmentPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `DtlEnvironment` object

class `azure.mgmt.devtestlabs.models.``SecretPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Secret` object

class `azure.mgmt.devtestlabs.models.``ServiceFabricPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ServiceFabric` object

class `azure.mgmt.devtestlabs.models.``LabVirtualMachinePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `LabVirtualMachine` object

class `azure.mgmt.devtestlabs.models.``VirtualNetworkPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `VirtualNetwork` object

class `azure.mgmt.devtestlabs.models.``EnableStatus`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.devtestlabs.models.``SourceControlType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `git_hub` = 'GitHub'
  `vso_git` = 'VsoGit'

class `azure.mgmt.devtestlabs.models.``StorageType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `premium` = 'Premium'
  `standard` = 'Standard'
  `standard_ssd` = 'StandardSSD'

class `azure.mgmt.devtestlabs.models.``CostThresholdStatus`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.devtestlabs.models.``WindowsOsState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `non_sysprepped` = 'NonSysprepped'
  `sysprep_applied` = 'SysprepApplied'
  `sysprep_requested` = 'SysprepRequested'

class `azure.mgmt.devtestlabs.models.``LinuxOsState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `deprovision_applied` = 'DeprovisionApplied'
  `deprovision_requested` = 'DeprovisionRequested'
  `non_deprovisioned` = 'NonDeprovisioned'

class `azure.mgmt.devtestlabs.models.``CustomImageOsType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `linux` = 'Linux'
  `none` = 'None'
  `windows` = 'Windows'

class `azure.mgmt.devtestlabs.models.``HostCachingOptions`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `none` = 'None'
  `read_only` = 'ReadOnly'
  `read_write` = 'ReadWrite'

class `azure.mgmt.devtestlabs.models.``NotificationChannelEventType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `auto_shutdown` = 'AutoShutdown'
  `cost` = 'Cost'

class `azure.mgmt.devtestlabs.models.``TransportProtocol`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `tcp` = 'Tcp'
  `udp` = 'Udp'

class `azure.mgmt.devtestlabs.models.``VirtualMachineCreationSource`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `from_custom_image` = 'FromCustomImage'
  `from_gallery_image` = 'FromGalleryImage'
  `from_shared_gallery_image` = 'FromSharedGalleryImage'

class `azure.mgmt.devtestlabs.models.``FileUploadOptions`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `none` = 'None'
  `upload_files_and_generate_sas_tokens` = 'UploadFilesAndGenerateSasTokens'

class `azure.mgmt.devtestlabs.models.``PremiumDataDisk`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.devtestlabs.models.``EnvironmentPermission`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `contributor` = 'Contributor'
  `reader` = 'Reader'

class `azure.mgmt.devtestlabs.models.``TargetCostStatus`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.devtestlabs.models.``ReportingCycleType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `calendar_month` = 'CalendarMonth'
  `custom` = 'Custom'

class `azure.mgmt.devtestlabs.models.``CostType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `projected` = 'Projected'
  `reported` = 'Reported'
  `unavailable` = 'Unavailable'

class `azure.mgmt.devtestlabs.models.``HttpStatusCode`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `accepted` = 'Accepted'
  `bad_gateway` = 'BadGateway'
  `bad_request` = 'BadRequest'
  `conflict` = 'Conflict'
  `continue_enum` = 'Continue'
  `created` = 'Created'
  `expectation_failed` = 'ExpectationFailed'
  `forbidden` = 'Forbidden'
  `gateway_timeout` = 'GatewayTimeout'
  `gone` = 'Gone'
  `http_version_not_supported` = 'HttpVersionNotSupported'
  `internal_server_error` = 'InternalServerError'
  `length_required` = 'LengthRequired'
  `method_not_allowed` = 'MethodNotAllowed'
  `moved_permanently` = 'MovedPermanently'
  `multiple_choices` = 'MultipleChoices'
  `no_content` = 'NoContent'
  `non_authoritative_information` = 'NonAuthoritativeInformation'
  `not_acceptable` = 'NotAcceptable'
  `not_found` = 'NotFound'
  `not_implemented` = 'NotImplemented'
  `not_modified` = 'NotModified'
  `ok` = 'OK'
  `partial_content` = 'PartialContent'
  `payment_required` = 'PaymentRequired'
  `precondition_failed` = 'PreconditionFailed'
  `proxy_authentication_required` = 'ProxyAuthenticationRequired'
  `redirect` = 'Redirect'
  `request_entity_too_large` = 'RequestEntityTooLarge'
  `request_timeout` = 'RequestTimeout'
  `request_uri_too_long` = 'RequestUriTooLong'
  `requested_range_not_satisfiable` = 'RequestedRangeNotSatisfiable'
  `reset_content` = 'ResetContent'
  `see_other` = 'SeeOther'
  `service_unavailable` = 'ServiceUnavailable'
  `switching_protocols` = 'SwitchingProtocols'
  `temporary_redirect` = 'TemporaryRedirect'
  `unauthorized` = 'Unauthorized'
  `unsupported_media_type` = 'UnsupportedMediaType'
  `unused` = 'Unused'
  `upgrade_required` = 'UpgradeRequired'
  `use_proxy` = 'UseProxy'

class `azure.mgmt.devtestlabs.models.``PolicyStatus`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.devtestlabs.models.``PolicyFactName`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `environment_template` = 'EnvironmentTemplate'
  `gallery_image` = 'GalleryImage'
  `lab_premium_vm_count` = 'LabPremiumVmCount'
  `lab_target_cost` = 'LabTargetCost'
  `lab_vm_count` = 'LabVmCount'
  `lab_vm_size` = 'LabVmSize'
  `schedule_edit_permission` = 'ScheduleEditPermission'
  `user_owned_lab_premium_vm_count` = 'UserOwnedLabPremiumVmCount'
  `user_owned_lab_vm_count` = 'UserOwnedLabVmCount'
  `user_owned_lab_vm_count_in_subnet` = 'UserOwnedLabVmCountInSubnet'

class `azure.mgmt.devtestlabs.models.``PolicyEvaluatorType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `allowed_values_policy` = 'AllowedValuesPolicy'
  `max_value_policy` = 'MaxValuePolicy'

class `azure.mgmt.devtestlabs.models.``UsagePermissionType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `allow` = 'Allow'
  `default` = 'Default'
  `deny` = 'Deny'